// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/billion/perform.c $
// $Rev: 53950 $
// $Date: 2023-11-29 06:48:48 -0600 (Wed, 29 Nov 2023) $

// 24DSI: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	_1B		(1000L * 1000L * 1000L)
#define	_1M		(1024L * 1024L)



// variables ******************************************************************

static	u32	_buffer[_1M];



//*****************************************************************************
static int _read_data(const args_t* args)
{
	int		errs	= 0;
	long	get;			// bytes
	long	got;
	long	samples	= 0;

	gsc_label("Reading");

	for (;;)
	{
		get	= (_1B - samples) * 4;

		if (get > (sizeof(_buffer)))
			get	= sizeof(_buffer);

		got	= dsi_read(args->fd, _buffer, get);

		if (got < 0)
		{
			errs	= 1;
			printf(	"FAIL <---  (read error, errno %d)\n", errno);
			break;
		}

		if (got != get)
		{
			errs	= 1;
			printf(	"FAIL <---  (total %ld, requested %ld samples, got %ld samples)\n",
					(long) samples,
					(long) get / 4,
					(long) got / 4);
			break;
		}

		samples	+= got / 4;

		if (samples >= _1B)
			break;
	}

	if (errs == 0)
		printf("PASS  (read %ld samples)\n", samples);

	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= dsi_config_ai	(args->fd, -1, 1, -1, args->fsamp);
	errs	+= dsi_rx_io_mode	(args->fd, -1, 1, args->io_mode, NULL);
	errs	+= dsi_ain_buf_clear(args->fd, -1, 1, 0);
	errs	+= _read_data		(args);

	return(errs);
}



