// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/fref/perform.c $
// $Rev: 53953 $
// $Date: 2023-11-29 06:52:19 -0600 (Wed, 29 Nov 2023) $

// 24DSI: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	time_t	end		= time(NULL) + args->seconds;
	int		errs;
	time_t	now;
	s32		pll;

	gsc_label("Fref Setup");
	printf("\n");
	gsc_label_level_inc();

	errs	= dsi_query(args->fd, -1, 1, DSI_QUERY_PLL_PRESENT, &pll);

	if (pll == 0)
	{
	}
	else
	{
		errs	+= dsi_initialize		(args->fd, -1, 1);
		errs	+= dsi_init_mode		(args->fd, -1, 1, DSI_INIT_MODE_INITIATOR, NULL);
		errs	+= dsi_ext_clk_src		(args->fd, -1, 1, DSI_EXT_CLK_SRC_GEN_A, NULL);
		errs	+= dsi_rate_gen_a_nvco	(args->fd, -1, 1, 25, NULL);
		errs	+= dsi_rate_gen_a_nref	(args->fd, -1, 1, 25, NULL);
		errs	+= dsi_xcvr_type		(args->fd, -1, 1, DSI_XCVR_TYPE_TTL, NULL);
	}

	gsc_label("Waiting");

	if (pll == 0)
	{
		printf("SKIPPED  (Legacy mode not supported by application)\n");
	}
	else
	{
		for (; errs == 0;)
		{
			now		= time(NULL);

			if (now > end)
				break;
		}

		printf("Done\n");
	}

	gsc_label_level_dec();
	return(errs);
}


