// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/mbsync/sync.c $
// $Rev: 53956 $
// $Date: 2023-11-29 06:55:21 -0600 (Wed, 29 Nov 2023) $

// 24DSI: Sample Application: source file

#include "main.h"



//*****************************************************************************
int multi_board_sync(const args_t* args, int errs, int* lp)
{
	s32	fsamp	= SAMPLE_RATE;
	int	range;

	//===============================================================
	gsc_label("Configuration");
	printf("\n");
	gsc_label_level_inc();

	if (errs)
	{
		printf("\t SKIPPED DUE TO ERRORS.\n");
	}
	else
	{
		errs	+= service_config			(args, fsamp);
		errs	+= service_rx_io_overflow	(args, DSI_IO_OVERFLOW_IGNORE, DSI_IO_OVERFLOW_IGNORE);
		errs	+= service_low_power		(args, lp);
		range	= lp[0] ? DSI_AIN_RANGE_5V : DSI_AIN_RANGE_10V;
		errs	+= service_ain_range		(args, range);
		errs	+= service_data_width		(args, DSI_DATA_WIDTH_16);
		errs	+= service_data_format		(args, DSI_DATA_FORMAT_OFF_BIN);
		errs	+= service_autocal			(args);
		errs	+= service_clear			(args);

		if (args->star)
		{
			// Star Configuration							Initiator					Each Target
			errs	+= service_init_mode			(args,	DSI_INIT_MODE_INITIATOR,	-1							);
			errs	+= service_channel_group_source	(args,	DSI_CH_GRP_SRC_EXTERN,		DSI_CH_GRP_SRC_EXTERN		);
			errs	+= service_extern_clock_source	(args,	DSI_EXT_CLK_SRC_GEN_A,		DSI_EXT_CLK_SRC_GEN_A		);
			errs	+= service_channel_order		(args,	DSI_CHANNEL_ORDER_SYNC);
		}
		else
		{
			// Daisy Chain Configiration					Initiator					Each Target
			errs	+= service_init_mode			(args,	DSI_INIT_MODE_INITIATOR,	DSI_INIT_MODE_TARGET		);
			errs	+= service_channel_group_source	(args,	DSI_CH_GRP_SRC_GEN_A,		DSI_CH_GRP_SRC_DIR_EXTERN	);
			errs	+= service_extern_clock_source	(args,	DSI_EXT_CLK_SRC_GRP_0,		-1							);
			errs	+= service_channel_order		(args,	DSI_CHANNEL_ORDER_SYNC);
		}
	}

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Scan Synchronize");
	printf("\n");
	gsc_label_level_inc();

	if (errs)
	{
		printf("\t SKIPPED DUE TO ERRORS.\n");
	}
	else
	{
		//										Initiator					Each Target
		errs	+= service_sw_sync_mode	(args,	DSI_SW_SYNC_MODE_SW_SYNC,	DSI_SW_SYNC_MODE_SW_SYNC	);
		errs	+= service_sw_sync		(args,	0,							-1							);
		errs	+= service_channel_ready(args,	0,							0							);
	}

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Data Synchronize");
	printf("\n");
	gsc_label_level_inc();

	if (errs)
	{
		printf("\t SKIPPED DUE TO ERRORS.\n");
	}
	else
	{
		//										Initiator					Each Target
		errs	+= service_sw_sync_mode	(args,	DSI_SW_SYNC_MODE_CLR_BUF,	DSI_SW_SYNC_MODE_CLR_BUF	);
		errs	+= service_sw_sync		(args,	0,							-1							);
		errs	+= service_channel_ready(args,	0,							0							);
	}

	gsc_label_level_dec();

	return(errs);
}


