// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/mbsync/validate.c $
// $Rev: 50995 $
// $Date: 2022-04-25 09:31:58 -0500 (Mon, 25 Apr 2022) $

// 24DSI: Sample Application: source file

#include "main.h"



// variables ******************************************************************

static	read_data_t		data[8];
static	volt_data_t		v_data[8];



//*****************************************************************************
int validate_sync(const args_t* args, int errs, int lp)
{
	gsc_label ("Validation");
	printf("\n");
	gsc_label_level_inc();

	if (errs)
	{
		printf("\t SKIPPED DUE TO ERRORS.\n");
	}
	else
	{
		errs	+= service_read					(args, data);
		errs	+= service_voltage_range_examine(args, data, v_data, lp);
		errs	+= service_voltage_range_samples(args, v_data);
		errs	+= service_voltage_range_vmax	(args, v_data, lp);
		errs	+= service_voltage_range_vmin	(args, v_data, lp);
		errs	+= service_data_rate_fsamp		(args, v_data);
		errs	+= service_data_rate_examine	(args, data, v_data);
		errs	+= service_data_rate_cycles		(args, v_data);
		errs	+= service_data_rate_period		(args, v_data);
		errs	+= service_data_rate_frequency	(args, v_data);
		errs	+= service_data_rate_phase		(args, data, v_data, lp);
	}

	gsc_label_level_dec();
	return(errs);
}


