// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/sbtest/ain_range_12_15.c $
// $Rev: 50999 $
// $Date: 2022-04-25 09:36:58 -0500 (Mon, 25 Apr 2022) $

// 24DSI: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI_IOCTL_AIN_RANGE_12_15,
			/* arg		*/	DSI_AIN_RANGE_2_5V,
			/* reg		*/	DSI_GSC_RFCR,
			/* mask		*/	0xC00000,
			/* value	*/	0x400000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI_IOCTL_AIN_RANGE_12_15,
			/* arg		*/	DSI_AIN_RANGE_5V,
			/* reg		*/	DSI_GSC_RFCR,
			/* mask		*/	0xC00000,
			/* value	*/	0x800000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI_IOCTL_AIN_RANGE_12_15,
			/* arg		*/	DSI_AIN_RANGE_10V,
			/* reg		*/	DSI_GSC_RFCR,
			/* mask		*/	0xC00000,
			/* value	*/	0xC00000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= dsi_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_get_list(fd, list);

	errs	+= service_ioctl_set_get_list(fd, list);

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// TBD
	return(0);
}



/******************************************************************************
*
*	Function:	ain_range_12_15_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI_IOCTL_AIN_RANGE_12_15
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ain_range_12_15_test(int fd)
{
	int	errs	= 0;
	s32	qty;
	s32	rfcr;

	gsc_label("DSI_IOCTL_AIN_RANGE_12_15");
	errs	+= dsi_query(fd, -1, 0, DSI_QUERY_CHANNEL_QTY, &qty);
	errs	+= dsi_query(fd, -1, 0, DSI_QUERY_RFCR, &rfcr);

	if (errs)
	{
	}
	else if ((rfcr == 0) || (qty <= 15))
	{
		printf("SKIPPED  (Not supported on this device.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


