// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/sbtest/perform.c $
// $Rev: 53960 $
// $Date: 2023-11-29 06:59:25 -0600 (Wed, 29 Nov 2023) $

// 24DSI: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= reg_read_test(args->fd);				// DSI_IOCTL_REG_READ
	errs	+= reg_write_test(args->fd);			// DSI_IOCTL_REG_WRITE
	errs	+= reg_mod_test(args->fd);				// DSI_IOCTL_REG_MOD
	errs	+= query_test(args->fd);				// DSI_IOCTL_QUERY
	errs	+= initialize_test(args->fd);			// DSI_IOCTL_INITIALIZE
	errs	+= autocal_test(args->fd);				// DSI_IOCTL_AUTOCAL

	errs	+= rx_io_abort_test(args->fd);			// DSI_IOCTL_RX_IO_ABORT
	errs	+= rx_io_mode_test(args->fd);			// DSI_IOCTL_RX_IO_MODE
	errs	+= rx_io_overflow_test(args->fd);		// DSI_IOCTL_RX_IO_OVERFLOW
	errs	+= rx_io_timeout_test(args->fd);		// DSI_IOCTL_RX_IO_TIMEOUT
	errs	+= rx_io_underflow_test(args->fd);		// DSI_IOCTL_RX_IO_UNDERFLOW

	errs	+= ain_buf_clear_test(args->fd);		// DSI_IOCTL_AIN_BUF_CLEAR
	errs	+= ain_buf_input_test(args->fd);		// DSI_IOCTL_AIN_BUF_INPUT
	errs	+= ain_buf_overflow_test(args->fd);		// DSI_IOCTL_AIN_BUF_OVERFLOW
	errs	+= ain_buf_thresh_test(args->fd);		// DSI_IOCTL_AIN_BUF_THRESH
	errs	+= ain_buf_underflow_test(args->fd);	// DSI_IOCTL_AIN_BUF_UNDERFLOW

	errs	+= ain_filter_test(args->fd);			// DSI_IOCTL_AIN_FILTER
	errs	+= ain_filter_sel_test(args->fd);		// DSI_IOCTL_AIN_FILTER_SEL
	errs	+= ain_filter_00_03_test(args->fd);		// DSI_IOCTL_AIN_FILTER_00_03
	errs	+= ain_filter_04_07_test(args->fd);		// DSI_IOCTL_AIN_FILTER_04_07
	errs	+= ain_filter_08_11_test(args->fd);		// DSI_IOCTL_AIN_FILTER_08_11
	errs	+= ain_filter_12_15_test(args->fd);		// DSI_IOCTL_AIN_FILTER_12_15
	errs	+= ain_filter_16_19_test(args->fd);		// DSI_IOCTL_AIN_FILTER_16_19
	errs	+= ain_filter_20_23_test(args->fd);		// DSI_IOCTL_AIN_FILTER_20_23
	errs	+= ain_filter_24_27_test(args->fd);		// DSI_IOCTL_AIN_FILTER_24_27
	errs	+= ain_filter_28_31_test(args->fd);		// DSI_IOCTL_AIN_FILTER_28_31

	errs	+= ain_mode_test(args->fd);				// DSI_IOCTL_AIN_MODE

	errs	+= ain_range_test(args->fd);			// DSI_IOCTL_AIN_RANGE
	errs	+= ain_range_sel_test(args->fd);		// DSI_IOCTL_AIN_RANGE_SEL
	errs	+= ain_range_00_03_test(args->fd);		// DSI_IOCTL_AIN_RANGE_00_03
	errs	+= ain_range_04_07_test(args->fd);		// DSI_IOCTL_AIN_RANGE_04_07
	errs	+= ain_range_08_11_test(args->fd);		// DSI_IOCTL_AIN_RANGE_08_11
	errs	+= ain_range_12_15_test(args->fd);		// DSI_IOCTL_AIN_RANGE_12_15
	errs	+= ain_range_16_19_test(args->fd);		// DSI_IOCTL_AIN_RANGE_16_19
	errs	+= ain_range_20_23_test(args->fd);		// DSI_IOCTL_AIN_RANGE_20_23
	errs	+= ain_range_24_27_test(args->fd);		// DSI_IOCTL_AIN_RANGE_24_27
	errs	+= ain_range_28_31_test(args->fd);		// DSI_IOCTL_AIN_RANGE_28_31

	errs	+= channel_order_test(args->fd);		// DSI_IOCTL_CHANNEL_ORDER
	errs	+= data_format_test(args->fd);			// DSI_IOCTL_DATA_FORMAT
	errs	+= data_width_test(args->fd);			// DSI_IOCTL_DATA_WIDTH
	errs	+= init_mode_test(args->fd);			// DSI_IOCTL_INIT_MODE
	errs	+= sw_sync_test(args->fd);				// DSI_IOCTL_SW_SYNC
	errs	+= sw_sync_mode_test(args->fd);			// DSI_IOCTL_SW_SYNC_MODE
	errs	+= pll_ref_freq_hz_test(args->fd);		// DSI_IOCTL_PLL_REF_FREQ_HZ

	errs	+= rate_gen_a_nvco_test(args->fd);		// DSI_IOCTL_RATE_GEN_A_NVCO
	errs	+= rate_gen_b_nvco_test(args->fd);		// DSI_IOCTL_RATE_GEN_B_NVCO
	errs	+= rate_gen_a_nref_test(args->fd);		// DSI_IOCTL_RATE_GEN_A_NREF
	errs	+= rate_gen_b_nref_test(args->fd);		// DSI_IOCTL_RATE_GEN_B_NREF
	errs	+= rate_gen_a_nrate_test(args->fd);		// DSI_IOCTL_RATE_GEN_A_NRATE
	errs	+= rate_gen_b_nrate_test(args->fd);		// DSI_IOCTL_RATE_GEN_B_NRATE
	errs	+= rate_div_0_ndiv_test(args->fd);		// DSI_IOCTL_RATE_DIV_0_NDIV
	errs	+= rate_div_1_ndiv_test(args->fd);		// DSI_IOCTL_RATE_DIV_1_NDIV

	errs	+= ch_grp_0_src_test(args->fd);			// DSI_IOCTL_CH_GRP_0_SRC
	errs	+= ch_grp_1_src_test(args->fd);			// DSI_IOCTL_CH_GRP_1_SRC
	errs	+= ch_grp_2_src_test(args->fd);			// DSI_IOCTL_CH_GRP_2_SRC
	errs	+= ch_grp_3_src_test(args->fd);			// DSI_IOCTL_CH_GRP_3_SRC

	errs	+= ext_clk_src_test(args->fd);			// DSI_IOCTL_EXT_CLK_SRC
	errs	+= ext_trig_test(args->fd);				// DSI_IOCTL_EXT_TRIG
	errs	+= thres_flag_cbl_test(args->fd);		// DSI_IOCTL_THRES_FLAG_CBL
	errs	+= xcvr_type_test(args->fd);			// DSI_IOCTL_XCVR_TYPE

	errs	+= gps_enable_test(args->fd);			// DSI_IOCTL_GPS_ENABLE
	errs	+= gps_locked_test(args->fd);			// DSI_IOCTL_GPS_LOCKED
	errs	+= gps_polarity_test(args->fd);			// DSI_IOCTL_GPS_POLARITY
	errs	+= gps_rate_locked_test(args->fd);		// DSI_IOCTL_GPS_RATE_LOCKED
	errs	+= gps_target_rate_test(args->fd);		// DSI_IOCTL_GPS_TARGET_RATE
	errs	+= gps_tolerance_test(args->fd);		// DSI_IOCTL_GPS_TOLERANCE

	errs	+= ain_coupling_test(args->fd);			// DSI_IOCTL_AIN_COUPLING
	errs	+= adc_rate_out_test(args->fd);			// DSI_IOCTL_ADC_RATE_OUT
	errs	+= rx_io_abort_test(args->fd);			// DSI_IOCTL_RX_IO_ABORT
	errs	+= irq_sel_test(args->fd);				// DSI_IOCTL_IRQ_SEL

	errs	+= wait_event_test(args->fd);			// DSI_IOCTL_WAIT_EVENT
	errs	+= wait_cancel_test(args->fd);			// DSI_IOCTL_WAIT_CANCEL
	errs	+= wait_status_test(args->fd);			// DSI_IOCTL_WAIT_STATUS

	errs	+= voltage_test(args->fd);

	return(errs);
}


