// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/sbtest/query.c $
// $Rev: 50999 $
// $Date: 2022-04-25 09:36:58 -0500 (Mon, 25 Apr 2022) $

// 24DSI: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI_IOCTL_QUERY. We test only the
*		overall service, not the values returned.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	gsc_label("DSI_IOCTL_QUERY");
	errs	= dsi_query(fd, -1, 0, DSI_QUERY_COUNT, &count);

	if (count != (DSI_IOCTL_QUERY_LAST + 1))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) DSI_IOCTL_QUERY_LAST + 1,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i < DSI_IOCTL_QUERY_LAST); i++)
		{
			errs	= dsi_query(fd, -1, 0, i, &data);

			if (errs)
			{
				printf("FAIL <---  (option %d)\n", i);
				break;
			}
		}

		if (errs == 0)
			printf("PASS\n");
	}


	return(errs);
}


