// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/sbtest/thres_flag_cbl.c $
// $Rev: 50999 $
// $Date: 2022-04-25 09:36:58 -0500 (Mon, 25 Apr 2022) $

// 24DSI: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI_IOCTL_THRES_FLAG_CBL,
			/* arg		*/	DSI_THRES_FLAG_CBL_OFF,
			/* reg		*/	DSI_GSC_BCTLR,
			/* mask		*/	0x400000,
			/* value	*/	0x000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DSI_IOCTL_THRES_FLAG_CBL,
			/* arg		*/	DSI_THRES_FLAG_CBL_OUT,
			/* reg		*/	DSI_GSC_BCTLR,
			/* mask		*/	0x400000,
			/* value	*/	0x400000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= dsi_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_get_list(fd, list);

	errs	+= service_ioctl_set_get_list(fd, list);

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// TBD
	return(0);
}



/******************************************************************************
*
*	Function:	thres_flag_cbl_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DSI_IOCTL_THRES_FLAG_CBL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int thres_flag_cbl_test(int fd)
{
	int	errs;
	s32	d22;

	gsc_label("DSI_IOCTL_THRES_FLAG_CBL");
	errs	= dsi_query(fd, -1, 0, DSI_QUERY_D22_THR_FLAG, &d22);

	if (errs)
	{
	}
	else if (d22 == 0)
	{
		printf("SKIPPED  (Not supported on this device.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


