// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/samples/signals/perform.c $
// $Rev: 53963 $
// $Date: 2023-11-29 07:02:25 -0600 (Wed, 29 Nov 2023) $

// 24DSI: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	time_t	end		= time(NULL) + args->seconds;
	int		errs	= 0;
	time_t	now;

	//===============================================================
	gsc_label("Setup");
	printf("\n");
	gsc_label_level_inc();

	errs	+= dsi_initialize	(args->fd, -1, 1);
	errs	+= dsi_init_mode	(args->fd, -1, 1, DSI_INIT_MODE_INITIATOR, NULL);
	errs	+= dsi_xcvr_type	(args->fd, -1, 1, args->xcvr_type, NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Clock Output");
	printf("\n");
	gsc_label_level_inc();

	errs	+= dsi_ext_clk_src		(args->fd, -1, 1, DSI_EXT_CLK_SRC_GEN_A, NULL);
	errs	+= dsi_rate_gen_a_nvco	(args->fd, -1, 1, 117, NULL);
	errs	+= dsi_rate_gen_a_nref	(args->fd, -1, 1, 125, NULL);
	errs	+= dsi_rate_gen_a_nrate	(args->fd, -1, 1, 17188, NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Sync Output");
	printf("(%d seconds)\n", (int) args->seconds);
	gsc_label_level_inc();
	gsc_label("Working");

	for (; errs == 0;)
	{
		errs	+= dsi_sw_sync(args->fd, -1, 0);
		now		= time(NULL);

		if (now > end)
			break;
	}

	printf("Done\n");
	gsc_label_level_dec();

	return(errs);
}



