// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/utils/util_ain_buf_overflow.c $
// $Rev: 42847 $
// $Date: 2018-05-18 10:29:53 -0500 (Fri, 18 May 2018) $

// 24DSI: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi_ain_buf_overflow
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI_IOCTL_AIN_BUF_OVERFLOW service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	dsi_ain_buf_overflow(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[128];
	int		errs	= 0;
	int		ret;

	if (verbose)
		gsc_label_index("ADC Buffer Overflow", index);

	if (set == -1)
	{
		ret		= dsi_ioctl(fd, DSI_IOCTL_AIN_BUF_OVERFLOW, &set);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		ret		= dsi_ioctl(fd, DSI_IOCTL_AIN_BUF_OVERFLOW, &set);
		errs	+= ret ? 1 : 0;
		set		= -1;
		ret		= dsi_ioctl(fd, DSI_IOCTL_AIN_BUF_OVERFLOW, &set);
		errs	+= ret ? 1 : 0;
	}

	if (set)
		strcpy(buf, "Yes");
	else
		strcpy(buf, "No");

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


