// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/utils/util_auto_calibrate.c $
// $Rev: 52688 $
// $Date: 2023-03-24 15:05:09 -0500 (Fri, 24 Mar 2023) $

// 24DSI: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi_auto_calibrate
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI_IOCTL_AUTO_CALIBRATE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	dsi_auto_calibrate(int fd, int index, int verbose)
{
	int	errs;
	s32	query;
	int	ret;

	if (verbose)
		gsc_label_index("Auto-Calibrate", index);

	errs	= dsi_query(fd, -1, 0, DSI_QUERY_AUTO_CAL_MS, &query);

	if (errs)
	{
	}
	else if (query)
	{
		ret		= dsi_ioctl(fd, DSI_IOCTL_AUTO_CALIBRATE, NULL);
		errs	= ret ? 1 : 0;

		if (verbose)
			printf("%s\n", errs ? "FAIL <---" : "PASS");
	}
	else
	{
		if (verbose)
			printf("SKIPPED  (Not supported on this device.)\n");
	}

	return(errs);
}


