// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/utils/util_channels_ready.c $
// $Rev: 52016 $
// $Date: 2022-11-21 09:01:02 -0600 (Mon, 21 Nov 2022) $

// 24DSI: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi_channels_ready
*
*	Purpose:
*
*		Provide a visual feedback for the DSI_IOCTL_CHANNELS_READY service.
*
*	Arguments:
*
*		fd		The handle to the device.
*
*		index	The index of the device.
*
*		verbose	Work verbosely? If not, then quietly.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi_channels_ready(int fd, int index, int verbose)
{
	int	errs;

	if (verbose)
		gsc_label_index("Channels Ready", index);

	errs	= dsi_ioctl(fd, DSI_IOCTL_CHANNELS_READY, NULL);

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);

}


