// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI/24DSI_Linux_3.x_and_4.x_GSC_DN/utils/util_gps_target_rate.c $
// $Rev: 52688 $
// $Date: 2023-03-24 15:05:09 -0500 (Fri, 24 Mar 2023) $

// 24DSI: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi_gps_target_rate
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI_IOCTL_GPS_TARGET_RATE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi_gps_target_rate(int fd, int index, int verbose, s32 set, s32* get)
{
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("GPS Target Rate", index);

	ret		= dsi_ioctl(fd, DSI_IOCTL_GPS_TARGET_RATE, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma(set);
		printf(" Hz)\n");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


